Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Cryptix V3.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## xjava.security
Class KeyGenerator

    java.lang.Object
      |
      +--xjava.security.KeyGenerator

Direct Known Subclasses:
  RawKeyGenerator

public abstract class KeyGenerator
extends java.lang.Object
implements Parameterized

The KeyGenerator class is used to generate keys for a given algorithm. Key generators are constructed using the `getInstance` factory methods (static methods that return instances of a given class).

The KeyGenerator interface is entirely algorithm independent, and, as for the KeyPairGenerator instances, KeyGenerator instances may be cast to algorithm-specific interfaces defined elsewhere in the Java Cryptography Architecture.

A typical set of calls would be:

        import java.security.KeyGenerator;

        SecureRandom random = new SecureRandom();
        KeyGenerator keygen = KeyGenerator.getInstance("DES");
        keygen.initialize(random);
        Key key = keygen.generateKey();

Copyright © 1997 Systemics Ltd on behalf of the Cryptix Development Team.
All rights reserved.

$Revision: 1.3 $

Since:
  IJCE 1.0.0
Author:
  David Hopwood, Raif S. Naffah

Constructor Summary
`protected` | `KeyGenerator(java.lang.String algorithm)` Creates a KeyGenerator object for the specified algorithm.

Method Summary
`java.lang.Object` | `clone()` Returns a clone of this key generator.
`protected java.lang.Object` | `engineGetParameter(java.lang.String param)` SPI: Gets the value of the specified algorithm parameter.
`protected void` | `engineSetParameter(java.lang.String param, java.lang.Object value)` SPI: Sets the specified algorithm parameter to the specified value.
`abstract SecretKey` | `generateKey()` Generates a key.
`java.lang.String` | `getAlgorithm()` Returns the standard name of the algorithm for this key generator.
`static java.lang.String[]` | `getAlgorithms()` Gets the standard names of all KeyGenerators implemented by any installed provider.
`static java.lang.String[]` | `getAlgorithms(java.security.Provider provider)` Gets the standard names of all KeyGenerators implemented by a provider.
`static KeyGenerator` | `getInstance(java.lang.String algorithm)` Generates a KeyGenerator object that implements the algorithm requested, as available in the environment.
`static KeyGenerator` | `getInstance(java.lang.String algorithm, java.lang.String provider)` Generates a KeyGenerator object implementing the specified algorithm, as supplied from the specified provider, if such an algorithm is available from the provider.
`java.lang.Object` | `getParameter(java.lang.String param)` Gets the value of the specified algorithm parameter.
`abstract void` | `initialize(java.security.SecureRandom random)` Initializes the key generator.
`void` | `setParameter(java.lang.String param, java.lang.Object value)` Sets the specified algorithm parameter to the specified value.
`java.lang.String` | `toString()`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### KeyGenerator

    protected KeyGenerator(java.lang.String algorithm)

  Creates a KeyGenerator object for the specified algorithm.
  Parameters:
    `algorithm` - the standard string name of the algorithm.
  Throws:
    NullPointerException - if algorithm == null

Method Detail

### getInstance

    public static KeyGenerator getInstance(java.lang.String algorithm)
                                    throws java.security.NoSuchAlgorithmException

  Generates a KeyGenerator object that implements the algorithm requested, as available in the environment.

  See International JCE Standard Algorithm Names for a list of KeyGenerator algorithm names.

  Parameters:
    `algorithm` - the standard name or an alias for the algorithm.
  Returns:
    the new KeyGenerator object.
  Throws:
    java.security.NoSuchAlgorithmException - if the algorithm is not available in the environment.

### getInstance

    public static KeyGenerator getInstance(java.lang.String algorithm,
                                           java.lang.String provider)
                                    throws java.security.NoSuchAlgorithmException,
                                           java.security.NoSuchProviderException

  Generates a KeyGenerator object implementing the specified algorithm, as supplied from the specified provider, if such an algorithm is available from the provider.

  See International JCE Standard Algorithm Names for a list of KeyGenerator algorithm names.

  Parameters:
    `algorithm` - the standard name or an alias for the algorithm.
    `provider` - the string name of the provider.
  Returns:
    the new KeyGenerator object.
  Throws:
    java.security.NoSuchAlgorithmException - if the algorithm is not available from the provider.
    java.security.NoSuchProviderException - if the provider is not available in the environment.

### getAlgorithm

    public java.lang.String getAlgorithm()

  Returns the standard name of the algorithm for this key generator.

  See International JCE Standard Algorithm Names for a list of KeyGenerator algorithm names.

  Returns:
    the standard string name of the algorithm.

### initialize

    public abstract void initialize(java.security.SecureRandom random)

  Initializes the key generator.
  Parameters:
    `random` - a source of randomness for this generator.

### generateKey

    public abstract SecretKey generateKey()

  Generates a key. This method generates a new key every time it is called.
  Returns:
    the new key.

### setParameter

    public void setParameter(java.lang.String param,
                             java.lang.Object value)
                      throws NoSuchParameterException,
                             java.security.InvalidParameterException,
                             InvalidParameterTypeException

  Sets the specified algorithm parameter to the specified value.

  This method supplies a general-purpose mechanism through which it is possible to set the various parameters of this object. A uniform algorithm-specific naming scheme for each parameter is desirable but left unspecified at this time.

  This method is not supported in JavaSoft's version of JCE.

  Specified by:
    setParameter in interface Parameterized
  Parameters:
    `param` - the string identifier of the parameter.
    `value` - the parameter value.
  Throws:
    NullPointerException - if param == null
    NoSuchParameterException - if there is no parameter with name param for this key generator implementation.
    java.security.InvalidParameterException - if the parameter exists but cannot be set.
    InvalidParameterTypeException - if value is the wrong type for this parameter.

### getParameter

    public java.lang.Object getParameter(java.lang.String param)
                                  throws NoSuchParameterException,
                                         java.security.InvalidParameterException

  Gets the value of the specified algorithm parameter.

  This method supplies a general-purpose mechanism through which it is possible to get the various parameters of this object. A uniform algorithm-specific naming scheme for each parameter is desirable but left unspecified at this time.

  This method is not supported in JavaSoft's version of JCE.

  Specified by:
    getParameter in interface Parameterized
  Parameters:
    `param` - the string name of the parameter.
  Returns:
    the object that represents the parameter value.
  Throws:
    NullPointerException - if param == null
    NoSuchParameterException - if there is no parameter with name param for this key generator implementation.
    java.security.InvalidParameterException - if the parameter exists but cannot be read.

### engineSetParameter

    protected void engineSetParameter(java.lang.String param,
                                      java.lang.Object value)
                               throws NoSuchParameterException,
                                      java.security.InvalidParameterException,
                                      InvalidParameterTypeException

  SPI: Sets the specified algorithm parameter to the specified value.

  This method supplies a general-purpose mechanism through which it is possible to set the various parameters of this object. A uniform algorithm-specific naming scheme for each parameter is desirable but left unspecified at this time.

  The default implementation always throws a NoSuchParameterException.

  This method is not supported in JavaSoft's version of JCE.

  Parameters:
    `param` - the string name of the parameter.
    `value` - the parameter value.
  Throws:
    NoSuchParameterException - if there is no parameter with name param for this key generator implementation.
    java.security.InvalidParameterException - if the parameter exists but cannot be set.
    InvalidParameterTypeException - if value is the wrong type for this parameter.

### engineGetParameter

    protected java.lang.Object engineGetParameter(java.lang.String param)
                                           throws NoSuchParameterException,
                                                  java.security.InvalidParameterException

  SPI: Gets the value of the specified algorithm parameter.

  This method supplies a general-purpose mechanism through which it is possible to get the various parameters of this object. A uniform algorithm-specific naming scheme for each parameter is desirable but left unspecified at this time.

  The default implementation always throws a NoSuchParameterException.

  This method is not supported in JavaSoft's version of JCE.

  Parameters:
    `param` - the string name of the parameter.
  Returns:
    the object that represents the parameter value.
  Throws:
    NoSuchParameterException - if there is no parameter with name param for this key generator implementation.
    java.security.InvalidParameterException - if the parameter exists but cannot be read.

### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

  Returns a clone of this key generator.

  Note: In JavaSoft's version of JCE, `KeyGenerator.clone()` is protected. This is not very useful, since then an application (as opposed to the key generator implementation itself) is not able to call it.

  Overrides:
    clone in class java.lang.Object
  Throws:
    java.lang.CloneNotSupportedException - if the key generator is not cloneable.

### toString

    public java.lang.String toString()

  Overrides:
    toString in class java.lang.Object

### getAlgorithms

    public static java.lang.String[] getAlgorithms(java.security.Provider provider)

  Gets the standard names of all KeyGenerators implemented by a provider.

  This method is not supported in JavaSoft's version of JCE. For compatibility you may wish to use `IJCE.getAlgorithms(provider, "KeyGenerator")` instead.

  Since:
    IJCE 1.0.1

### getAlgorithms

    public static java.lang.String[] getAlgorithms()

  Gets the standard names of all KeyGenerators implemented by any installed provider. Algorithm names are not duplicated if they are supported by more than one provider.

  This method is not supported in JavaSoft's version of JCE. For compatibility you may wish to use `IJCE.getAlgorithms("KeyGenerator")` instead.

  Since:
    IJCE 1.0.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Cryptix V3.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) 1995-2000 The Cryptix Foundation Ltd. All rights reserved.